//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace Tecan.Sila2.Interop.Client.BinaryTransferTest
{
    
    
    /// <summary>
    /// Response type for the Echo Binary And Metadata String command
    /// </summary>
    [Tecan.Sila2.SilaDisplayNameAttribute("Echo Binary And Metadata String - Response")]
    public struct EchoBinaryAndMetadataStringResponse
    {
        
        private System.IO.Stream _binary;
        
        private string _stringMetadata;
        
        /// <summary>
        /// Initializes a new instance
        /// </summary>
        public EchoBinaryAndMetadataStringResponse(System.IO.Stream binary, string stringMetadata)
        {
            _binary = binary;
            _stringMetadata = stringMetadata;
        }
        
        /// <summary>
        /// The received binary
        /// </summary>
        public System.IO.Stream Binary
        {
            get
            {
                return _binary;
            }
        }
        
        /// <summary>
        /// The received String Metadata
        /// </summary>
        public string StringMetadata
        {
            get
            {
                return _stringMetadata;
            }
        }
    }
    
    /// <summary>
    /// Provides commands and properties to set or respectively get the SiLA Basic Data Type Binary via command parameters or property responses respectively.
    /// </summary>
    [Tecan.Sila2.SilaFeatureAttribute(true, "test")]
    [Tecan.Sila2.SilaIdentifierAttribute("BinaryTransferTest")]
    [Tecan.Sila2.SilaDisplayNameAttribute("Binary Transfer Test")]
    public partial interface IBinaryTransferTest
    {
        
        /// <summary>
        /// Returns the UTF-8 encoded string 'SiLA2_Test_String_Value' directly transmitted as Binary value.
        /// </summary>
        System.IO.Stream BinaryValueDirectly
        {
            get;
        }
        
        /// <summary>
        /// Returns the Binary Transfer UUID to be used to download the binary data which is the UTF-8 encoded string
        /// 'A_slightly_longer_SiLA2_Test_String_Value_used_to_demonstrate_the_binary_download', repeated 100,000 times.
        /// </summary>
        System.IO.Stream BinaryValueDownload
        {
            get;
        }
        
        /// <summary>
        /// Receives a Binary value (transmitted either directly or via binary transfer) and
        /// returns the received value.
        /// </summary>
        /// <param name="binaryValue">The Binary value to be returned.</param>
        /// <returns>The received Binary value transmitted in the same way it has been received.</returns>
        [return: Tecan.Sila2.SilaIdentifierAttribute("ReceivedValue")]
        System.IO.Stream EchoBinaryValue(System.IO.Stream binaryValue);
        
        /// <summary>
        /// Receives a list of binaries, echoes them individually as intermediate responses with a delay of 1 second, and then returns them as a single joint binary
        /// </summary>
        /// <param name="binaries">List of binaries to echo</param>
        /// <returns>A single binary comprised of binaries received as parameter</returns>
        [Tecan.Sila2.ObservableAttribute()]
        [return: Tecan.Sila2.SilaIdentifierAttribute("JointBinary")]
        Tecan.Sila2.IIntermediateObservableCommand<System.IO.Stream, System.IO.Stream> EchoBinariesObservably(System.Collections.Generic.ICollection<System.IO.Stream> binaries);
        
        /// <summary>
        /// Receives a Binary and requires String Metadata, returns both
        /// </summary>
        /// <param name="binary">The binary to echo</param>
        /// <returns>The received binary, The received String Metadata</returns>
        [return: Tecan.Sila2.InlineStructAttribute()]
        EchoBinaryAndMetadataStringResponse EchoBinaryAndMetadataString(System.IO.Stream binary);
    }
}
